From deb7a7f4be475755501c487ce0a3c5f53e1cea04 Mon Sep 17 00:00:00 2001
From: Eric Barbour <ebarbour@redhat.com>
Date: Aug 10 2016 19:35:20 +0000
Subject: [PATCH 6/16] Add widget ability to my stream page


Clean up a lot of the JS code
Pull save button out to own (pure) component

---

diff --git a/hubs/app.py b/hubs/app.py
index 3036b6e..a9d1893 100755
--- a/hubs/app.py
+++ b/hubs/app.py
@@ -549,6 +549,7 @@ def apply_html(actions):
 @app.route('/<name>/stream/')
 @login_required
 def stream(name):
+    hub = get_hub(session, name)
     saved = hubs.models.SavedNotification.by_username(session, name)
     saved = [n.__json__() for n in saved]
 
@@ -615,6 +616,7 @@ def stream(name):
     actions = json.dumps(actions, cls=hubs.widgets.feed.PythonObjectEncoder)
     return flask.render_template(
         'stream.html',
+        hub=hub,
         saved=json.dumps(saved),
         actions=actions
     )
@@ -632,7 +634,6 @@ def notifications(user):
     if flask.request.method == 'POST':
         data = flask.request.json
         try:
-            # TODO clean these with pingou's new method
             markup = data['markup']
             link = data['link']
             icon = data['secondary_icon']
diff --git a/hubs/models.py b/hubs/models.py
index 48ed913..68197d8 100755
--- a/hubs/models.py
+++ b/hubs/models.py
@@ -34,7 +34,7 @@ from sqlalchemy import create_engine
 from sqlalchemy.ext.declarative import declarative_base
 from sqlalchemy.orm import sessionmaker
 from sqlalchemy.orm import scoped_session
-from sqlalchemy.orm import relation, relationship
+from sqlalchemy.orm import relation
 from sqlalchemy.orm import backref
 
 import fedmsg
@@ -354,7 +354,7 @@ class User(BASE):
     username = sa.Column(sa.Text, primary_key=True)
     fullname = sa.Column(sa.Text)
     created_on = sa.Column(sa.DateTime, default=datetime.datetime.utcnow)
-    saved_notifications = relationship('SavedNotification', backref='users',
+    saved_notifications = relation('SavedNotification', backref='users',
                                        lazy='dynamic')
 
     def __json__(self, session):
diff --git a/hubs/static/client/app/components/Feed.jsx b/hubs/static/client/app/components/Feed.jsx
index bb5aa16..4562dcd 100644
--- a/hubs/static/client/app/components/Feed.jsx
+++ b/hubs/static/client/app/components/Feed.jsx
@@ -33,7 +33,8 @@ export default class Feed extends React.Component {
   }
   render() {
     const feedNodes = this.state.matches.map((match, idx) => {
-      return <Panel match={match} key={idx} />;
+      const saveUrl = this.props.saveUrl || null;
+      return <Panel match={match} saveUrl={saveUrl} key={idx} />;
     });
     return (
       <div>
diff --git a/hubs/static/client/app/components/Panel.jsx b/hubs/static/client/app/components/Panel.jsx
index 3bfd96a..7760893 100644
--- a/hubs/static/client/app/components/Panel.jsx
+++ b/hubs/static/client/app/components/Panel.jsx
@@ -2,30 +2,16 @@ import React from 'react';
 
 import Icon from './Icon.jsx';
 import Markup from './Markup.jsx';
+import SaveNotificationButton from './SaveNotificationButton.jsx';
 
 const Panel = function (props) {
-  const payload = {
-    link: props.match.link,
-    markup: props.match.markup,
-    secondary_icon: props.match.secondary_icon,
-    dom_id: props.match.dom_id,
-  };
-
-  function onClick(data) {
-    $.ajax({
-      type: 'POST',
-      url: '/atelic/notifications/',
-      data: JSON.stringify(data),
-      contentType: 'application/json',
-    }).done(resp => {
-      const id = "#save" + props.match.dom_id;
-      const $saveBtn = $(id);
-      $saveBtn.removeClass('btn-default').addClass('btn-success').text('SAVED')
-    });
-  }
   let saveBtn;
-  if (!props.match.saved) {
-    saveBtn = (<button id={'save' + props.match.dom_id} onClick={onClick.bind(this, payload)} className="btn btn-sm btn-default">SAVE</button>);
+  if (!props.match.saved && props.saveUrl) {
+    saveBtn = (
+      <SaveNotificationButton
+        match={props.match}
+        saveUrl={props.saveUrl}
+      />);
   }
 
   return (
diff --git a/hubs/static/client/app/components/SaveNotificationButton.jsx b/hubs/static/client/app/components/SaveNotificationButton.jsx
new file mode 100644
index 0000000..2b82d78
--- /dev/null
+++ b/hubs/static/client/app/components/SaveNotificationButton.jsx
@@ -0,0 +1,34 @@
+import React from 'react';
+
+const SaveNotificationButton = function (props) {
+  const payload = {
+    link: props.match.link,
+    markup: props.match.markup,
+    secondary_icon: props.match.secondary_icon,
+    dom_id: props.match.dom_id,
+  };
+
+  function onClick(data) {
+    $.ajax({
+      type: 'POST',
+      url: props.saveUrl,
+      data: JSON.stringify(data),
+      contentType: 'application/json',
+    }).done(() => {
+      const id = '#save' + props.match.dom_id;
+      const $saveBtn = $(id);
+      $saveBtn.removeClass('btn-default').addClass('btn-success').text('SAVED');
+    });
+  }
+  return (
+    <button
+      id={'save' + props.match.dom_id}
+      onClick={onClick.bind(this, payload)}
+      className="btn btn-sm btn-default"
+    >
+      SAVE
+    </button>
+  );
+};
+
+export default SaveNotificationButton;
